<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::OpenSenseUtilities Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1OpenSenseUtilities.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1OpenSenseUtilities-members.html">List of all members</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::OpenSenseUtilities Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a5e2079c3743620d18b4f62e50fe083d0"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#a5e2079c3743620d18b4f62e50fe083d0">rotateOrientationTable</a> (<a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;quaternionsTable, const SimTK::Rotation_&lt; double &gt; &amp;rotationMatrix)</td></tr>
<tr class="memdesc:a5e2079c3743620d18b4f62e50fe083d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Apply the passed in Rotation matrix to a TimeSeriesTable of Quaternions.  <a href="classOpenSim_1_1OpenSenseUtilities.html#a5e2079c3743620d18b4f62e50fe083d0">More...</a><br /></td></tr>
<tr class="separator:a5e2079c3743620d18b4f62e50fe083d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad843e721366bed67fd45a2f68f7675e"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#aad843e721366bed67fd45a2f68f7675e">createOrientationsFileFromMarkers</a> (const std::string &amp;markersFile)</td></tr>
<tr class="memdesc:aad843e721366bed67fd45a2f68f7675e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create Orientations as a TimeSeriesTable based on passed in markerFile.  <a href="classOpenSim_1_1OpenSenseUtilities.html#aad843e721366bed67fd45a2f68f7675e">More...</a><br /></td></tr>
<tr class="separator:aad843e721366bed67fd45a2f68f7675e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7d6de162cf44ccfcfff7563863ccce9"><td class="memItemLeft" align="right" valign="top">static SimTK::Transform&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#aa7d6de162cf44ccfcfff7563863ccce9">formTransformFromPoints</a> (const SimTK::Vec3 &amp;op, const SimTK::Vec3 &amp;xp, const SimTK::Vec3 &amp;yp)</td></tr>
<tr class="memdesc:aa7d6de162cf44ccfcfff7563863ccce9"><td class="mdescLeft">&#160;</td><td class="mdescRight">form a Transform from 3 points origin (op), along x (xp - op), along y(yp - op)  <a href="classOpenSim_1_1OpenSenseUtilities.html#aa7d6de162cf44ccfcfff7563863ccce9">More...</a><br /></td></tr>
<tr class="separator:aa7d6de162cf44ccfcfff7563863ccce9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b83aec74c57b51becabfb0468e59e5d"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; <a class="el" href="classOpenSim_1_1IMU.html">OpenSim::IMU</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#a9b83aec74c57b51becabfb0468e59e5d">addModelIMUs</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, std::vector&lt; std::string &gt; &amp;paths)</td></tr>
<tr class="memdesc:a9b83aec74c57b51becabfb0468e59e5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add IMUs to passed in model and return references to them based on paths specification.  <a href="classOpenSim_1_1OpenSenseUtilities.html#a9b83aec74c57b51becabfb0468e59e5d">More...</a><br /></td></tr>
<tr class="separator:a9b83aec74c57b51becabfb0468e59e5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Convert Table of Quaternions into a Table for Rotations</div></td></tr>
<tr class="memitem:a519e54c07f75507f0c3c9ee0ad96a143"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Rotation_&lt; double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#a519e54c07f75507f0c3c9ee0ad96a143">convertQuaternionsToRotations</a> (const <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;qauternionsTable)</td></tr>
<tr class="memdesc:a519e54c07f75507f0c3c9ee0ad96a143"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a TimeSeriesTable with quaternions as data elements into a TimeSeriesTable of Rotation matrices.  <a href="classOpenSim_1_1OpenSenseUtilities.html#a519e54c07f75507f0c3c9ee0ad96a143">More...</a><br /></td></tr>
<tr class="separator:a519e54c07f75507f0c3c9ee0ad96a143"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af11d1becefdada1845d5d243c85d47e7"><td class="memItemLeft" align="right" valign="top">static SimTK::Vec3&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html#af11d1becefdada1845d5d243c85d47e7">computeHeadingCorrection</a> (<a class="el" href="classOpenSim_1_1Model.html">OpenSim::Model</a> &amp;model, const SimTK::State &amp;state, <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;quatTimeSeries, const std::string &amp;baseIMU, const SimTK::CoordinateDirection)</td></tr>
<tr class="memdesc:af11d1becefdada1845d5d243c85d47e7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute a SimTK::Vec3 of Space-fixed XYZ Euler angles that aligns the specified baseIMU and CoordinateDirection combination with the positive X-axis (= typically forward) direction of the base segment in <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model.  <a href="classOpenSim_1_1OpenSenseUtilities.html#af11d1becefdada1845d5d243c85d47e7">More...</a><br /></td></tr>
<tr class="separator:af11d1becefdada1845d5d243c85d47e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a9b83aec74c57b51becabfb0468e59e5d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b83aec74c57b51becabfb0468e59e5d">&#9670;&nbsp;</a></span>addModelIMUs()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::vector&lt; <a class="el" href="classOpenSim_1_1IMU.html">OpenSim::IMU</a>* &gt; OpenSim::OpenSenseUtilities::addModelIMUs </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>paths</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add IMUs to passed in model and return references to them based on paths specification. </p>
<ul>
<li>If "paths" refer to user specified list of frames, then one new "{Frame}_imu" is added to the model and returned in result. </li>
</ul>

</div>
</div>
<a id="af11d1becefdada1845d5d243c85d47e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af11d1becefdada1845d5d243c85d47e7">&#9670;&nbsp;</a></span>computeHeadingCorrection()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static SimTK::Vec3 OpenSim::OpenSenseUtilities::computeHeadingCorrection </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">OpenSim::Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>quatTimeSeries</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>baseIMU</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::CoordinateDirection&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute a SimTK::Vec3 of Space-fixed XYZ Euler angles that aligns the specified baseIMU and CoordinateDirection combination with the positive X-axis (= typically forward) direction of the base segment in <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model. </p>
<p>Base segment is typically the segment attached directly to <a class="el" href="classOpenSim_1_1Ground.html" title="Ground is an inertial reference frame in which the motion of all Frames and points may conveniently a...">Ground</a>. baseIMU is assumed to be placed on Base segment. Passed in state places the model in the same configuration as the first frame of the passed in table of quaternions quatTimeSeries. </p>

</div>
</div>
<a id="a519e54c07f75507f0c3c9ee0ad96a143"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a519e54c07f75507f0c3c9ee0ad96a143">&#9670;&nbsp;</a></span>convertQuaternionsToRotations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt;SimTK::Rotation_&lt;double&gt; &gt; OpenSim::OpenSenseUtilities::convertQuaternionsToRotations </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>qauternionsTable</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a TimeSeriesTable with quaternions as data elements into a TimeSeriesTable of Rotation matrices. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoOrientationTrackingGoal.html#ac94a24ec011cb1a689ae8d90a10a9d82">OpenSim::MocoOrientationTrackingGoal::setRotationReference()</a>.</p>

</div>
</div>
<a id="aad843e721366bed67fd45a2f68f7675e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aad843e721366bed67fd45a2f68f7675e">&#9670;&nbsp;</a></span>createOrientationsFileFromMarkers()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt;SimTK::Quaternion_&lt;double&gt; &gt; OpenSim::OpenSenseUtilities::createOrientationsFileFromMarkers </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>markersFile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create Orientations as a TimeSeriesTable based on passed in markerFile. </p>

</div>
</div>
<a id="aa7d6de162cf44ccfcfff7563863ccce9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa7d6de162cf44ccfcfff7563863ccce9">&#9670;&nbsp;</a></span>formTransformFromPoints()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static SimTK::Transform OpenSim::OpenSenseUtilities::formTransformFromPoints </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vec3 &amp;&#160;</td>
          <td class="paramname"><em>op</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vec3 &amp;&#160;</td>
          <td class="paramname"><em>xp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vec3 &amp;&#160;</td>
          <td class="paramname"><em>yp</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>form a Transform from 3 points origin (op), along x (xp - op), along y(yp - op) </p>

</div>
</div>
<a id="a5e2079c3743620d18b4f62e50fe083d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e2079c3743620d18b4f62e50fe083d0">&#9670;&nbsp;</a></span>rotateOrientationTable()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::OpenSenseUtilities::rotateOrientationTable </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">OpenSim::TimeSeriesTable_</a>&lt; SimTK::Quaternion_&lt; double &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>quaternionsTable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Rotation_&lt; double &gt; &amp;&#160;</td>
          <td class="paramname"><em>rotationMatrix</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Apply the passed in Rotation matrix to a TimeSeriesTable of Quaternions. </p>
<p>The rotation is done in place so the table passed in is modified </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Simulation/OpenSense/OpenSenseUtilities.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1OpenSenseUtilities.html">OpenSenseUtilities</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:48 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
